function dy = mdeglat(lat)

% dy = mdeglat(lat)
%
% MDEGLAT- used in converting lat/lon <-> xy
% Meters per degree Latitude at the given Latitude
%
% INPUT
% lon - longitude in decimal degrees
%
% OUTPUT
% dx - meters per degree latitude
%
% SEE ALSO
% xy2ll.m and ll2xy.m
% mdeglon.m and mdeglat.m

latrad = lat*2*pi/360 ;

dy = 111132.09 - 566.05 * cos(2.0*latrad) ...
	+ 1.20 * cos(4.0*latrad) ...
	- 0.002 * cos(6.0*latrad) ;
