function dx = mdeglon(lat)

% dx = mdeglon(lat)
%
% MDEGLON - used in converting lat/lon <-> xy
% Meters per degree Longitude at the given Latitude
%
% INPUT
% lat - latitude in decimal degrees
%
% OUTPUT
% dx - meters per degree longitude
%
% SEE ALSO
% xy2ll.m and ll2xy.m
% mdeglon.m and mdeglat.m

latrad = lat*2*pi/360 ;

dx = 111415.13 * cos(latrad) ...
	- 94.55 * cos(3.0*latrad) ...
	+ 0.12 * cos(5.0*latrad);