function [lat,lon] = xy2ll(x, y, orglat, orglon)

% [lat,lon] = xy2ll(x, y, orglat, orglon)
%
% XY2LL
% Converts Alvin XY's to Lat/Lon (WGS84) using a Mercator projection.
%
% INPUT
% x - Easting in m (Alvin local grid)
% y - Northing in m (Alvin local grid)
% orglat - origin location latitude in decimal degrees
% orglon - origin location longitude in decimal degrees
% 
% OUTPUT
% lat - Latitude in decimal degrees
% lon - Longitude in decimal degrees
%
% HISTORY
%
%
% SEE ALSO
% ll2xy.m
% mdeglon.m and mdeglat.m
%

lon = x/mdeglon(orglat) + orglon;
lat = y/mdeglat(orglat) + orglat;



